//---------------------------------------------------------------------------
#ifndef TGameFormH
#define TGameFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Menus.hpp>
#include <ImgList.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
class TGameSystem;
//---------------------------------------------------------------------------
class TGameForm : public TForm
{
__published:
	TImageList *ImageList1;
	TMainMenu *MainMenu1;
	TMenuItem *Game_MenuItem;
	TMenuItem *New_MenuItem;
	TMenuItem *Status_MenuItem;
	TMenuItem *Clear_MenuItem;
	TMenuItem *Options_MenuItem;
	TMenuItem *ForkCount_MenuItem;
	TMenuItem *DishCount_MenuItem;
	TMenuItem *Speed_MenuItem;
	TMenuItem *SenseMouseUp_MenuItem;
	TMenuItem *RestorePosition_MenuItem;
	TMenuItem *PlaySound_MenuItem;
	TMenuItem *Default_MenuItem;
	TMenuItem *Exit_MenuItem;
	TMenuItem *Help1_MenuItem;
	TMenuItem *Help2_MenuItem;
	TMenuItem *Tips_MenuItem;
	TMenuItem *About_MenuItem;
	TPopupMenu *PopupMenu1;
	TMenuItem *NewP_MenuItem;
	TMenuItem *StatusP_MenuItem;
	TMenuItem *N1;
	TMenuItem *N2;
	TMenuItem *N3;
	TMenuItem *N4;
	TMenuItem *N5;
	TMenuItem *N6;
	TMenuItem *N7;
	void __fastcall ApplicationDeactivate(TObject *Sender);
	void __fastcall FormPaint(TObject *Sender);
	void __fastcall FormMouseDown(TObject *Sender, TMouseButton Button,
		TShiftState Shift, int X, int Y);
	void __fastcall FormMouseUp(TObject *Sender, TMouseButton Button,
		TShiftState Shift, int X, int Y);
	void __fastcall FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift);
	void __fastcall MenuItemClick(TObject *Sender);
	void __fastcall PopupMenu1Popup(TObject *Sender);
	void __fastcall GameSystemModeChange(TObject *Sender);
	void __fastcall GameTimerTimer(TObject *Sender);

private:
	enum OPTIONS { OPTIONS_FORKCOUNT, OPTIONS_DISHECOUNT, OPTIONS_SPEED,
		OPTIONS_SENSEMOUSEUP, OPTIONS_RESTOREPOSITION, OPTIONS_PLAYSOUND, OPTIONS_DEFAULT };
	enum SHOWINFO { SHOWINFO_STATUS, SHOWINFO_HELP, SHOWINFO_TIPS, SHOWINFO_ABOUT };
	int FSpeed;
	bool FSenseMouseUp;
	bool FRestorePosition;

	void __fastcall SetSpeed(int ASpeed);
	void __fastcall SetSenseMouseUp(bool ASenseMouseUp);
	void __fastcall SetRestorePosition(bool ARestorePosition);
	int __fastcall Saturate(int AValue, int AMin, int AMax);
	void __fastcall UpdateState();
	void __fastcall DiscardGame();

	void __fastcall ProcNew();
	void __fastcall ProcClear();
	void __fastcall ProcOptions(OPTIONS AType);
	void __fastcall ProcShowInfo(SHOWINFO AType);

	void __fastcall InitSettings();
	void __fastcall LoadSettings();
	void __fastcall SaveSettings();

protected:
	void __fastcall WMMenuSelect(TMessage& AMessage);

public:
	__fastcall TGameForm(TComponent* Owner);
	__fastcall virtual ~TGameForm();

	__property int Speed = {read=FSpeed, write=SetSpeed};
	__property bool SenseMouseUp = {read=FSenseMouseUp, write=SetSenseMouseUp};
	__property bool RestorePosition = {read=FRestorePosition, write=SetRestorePosition};

	BEGIN_MESSAGE_MAP
		MESSAGE_HANDLER(WM_MENUSELECT, TMessage, WMMenuSelect)
	END_MESSAGE_MAP(TForm)
};
//---------------------------------------------------------------------------
extern PACKAGE TGameForm* GameForm;
//---------------------------------------------------------------------------
#endif

