//---------------------------------------------------------------------------
#ifndef TGameScreenH
#define TGameScreenH
#include <Classes.hpp>
//---------------------------------------------------------------------------
const int UNITW = 32;
const int UNITH = 32;
const int GRIDW = 12;
const int GRIDH = 10;
const TRect SCRR(0, 0, UNITW * GRIDW, UNITH * GRIDH);
//---------------------------------------------------------------------------
class TGameScreen
{
private:
	Graphics::TBitmap* FOffScreen;
	TCanvas* FSrcCanvas;
	TCanvas* FDstCanvas;
	TImageList* FUnitImages;

	bool __fastcall GetModified();
	void __fastcall SetModified(bool AModified);

public:
	__fastcall TGameScreen();
	__fastcall virtual ~TGameScreen();

	bool __fastcall Contains(int AX, int AY);
	void __fastcall Update();

	__property TCanvas* SrcCanvas = {read=FSrcCanvas};
	__property TCanvas* DstCanvas = {read=FDstCanvas, write=FDstCanvas};
	__property TImageList* UnitImages = {read=FUnitImages, write=FUnitImages};
	__property bool Modified = {read=GetModified, write=SetModified};
};
//---------------------------------------------------------------------------
extern PACKAGE TGameScreen* GameScreen;  // created by GameForm
//---------------------------------------------------------------------------
#endif
