//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "TGameSound.h"
//---------------------------------------------------------------------------
TGameSound* GameSound = NULL;
//---------------------------------------------------------------------------
static const AnsiString SOUND_PATH = ExtractFilePath(Application->ExeName) + "Sound\\";
static const AnsiString SOUND_FILENAMES[] = { "Score.wav", "Miss.wav", "GameOver.wav" };
//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
// class TGameSound
//---------------------------------------------------------------------------
// private:
//---------------------------------------------------------------------------
void __fastcall TGameSound::Init()
{
	TFileStream* stream = NULL;

	__try {
		try {
			// init pointers to wave data
			for(int i = 0; i < GAMESOUNDCOUNT; i++)
				FWaves[i] = NULL;

			// load wave data from file
			for(int i = 0; i < GAMESOUNDCOUNT; i++) {
				stream = new TFileStream(SOUND_PATH + SOUND_FILENAMES[i], fmOpenRead | fmShareExclusive);
				if(stream->Size >= 1) {
					FWaves[i] = new unsigned char[stream->Size];
					stream->Position = 0;
					stream->Read(FWaves[i], stream->Size);
				}
				delete stream; stream = NULL;
			}
		}
		catch(...) {}
	}
	__finally {
		delete stream;
	}
}
//---------------------------------------------------------------------------
void __fastcall TGameSound::Uninit()
{
	Stop();

	for(int i = 0; i < GAMESOUNDCOUNT; i++) {
		delete [] FWaves[i]; FWaves[i] = NULL;
	}
}
//---------------------------------------------------------------------------
// public:
//---------------------------------------------------------------------------
__fastcall TGameSound::TGameSound() : FEnabled(true)
{
	Init();
}
//---------------------------------------------------------------------------
__fastcall TGameSound::~TGameSound()
{
	Uninit();
}
//---------------------------------------------------------------------------
void __fastcall TGameSound::Play(GAMESOUND AType)
{
	if(!Enabled) return;

	int index;
	switch(AType) {
		case GAMESOUND_SCORE : index = 0; break;
		case GAMESOUND_MISS : index = 1; break;
		case GAMESOUND_GAMEOVER : index = 2; break;
		default: return;
	}
	PlaySound(FWaves[index], NULL, SND_ASYNC | SND_MEMORY | SND_NODEFAULT);
}
//---------------------------------------------------------------------------
void __fastcall TGameSound::Stop() 
{
	PlaySound(NULL, NULL, SND_SYNC | SND_NODEFAULT);
}
//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
#pragma package(smart_init)
