//---------------------------------------------------------------------------
#ifndef TGameSystemH
#define TGameSystemH
#include <Classes.hpp>
//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
enum GAMEMODE { GAMEMODE_TITLE, GAMEMODE_READY, GAMEMODE_PLAYING,
	GAMEMODE_GAMEOVER, GAMEMODE_QUIT, GAMEMODE_NONE };
//---------------------------------------------------------------------------
class TGameUnitList;
//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
struct TGameOptions
{
	int ForkCount;
	int DishCount;

	__fastcall TGameOptions();
	__fastcall virtual ~TGameOptions();
	bool __fastcall operator==(const TGameOptions& ASrc) const;
	bool __fastcall operator!=(const TGameOptions& ASrc) const;
};
//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
class TGameSystem
{
private:
	GAMEMODE FMode;
	TGameUnitList* FUnitList;
	int FScore;
	int FHighScore;
	TGameOptions FOptions;
	TNotifyEvent FOnModeChange;

	void __fastcall SetMode(GAMEMODE AMode);
	void __fastcall DoModeChange();

public:
	__fastcall TGameSystem();
	__fastcall virtual ~TGameSystem();

	// game play
	void __fastcall Move();
	void __fastcall MouseDown(int AX, int AY);
	void __fastcall KeyDown(WORD AKey);

	__property GAMEMODE Mode = {read=FMode, write=SetMode};
	__property TGameUnitList* UnitList = {read=FUnitList};
	__property int Score = {read=FScore, write=FScore};
	__property int HighScore = {read=FHighScore, write=FHighScore};
	__property TGameOptions Options = {read=FOptions, write=FOptions};
	__property TNotifyEvent OnModeChange = {read=FOnModeChange, write=FOnModeChange};
};
//---------------------------------------------------------------------------
extern PACKAGE TGameSystem* GameSystem;  // created by GameForm
//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
#endif
